package beautiful06.step1;

import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import beautiful06.dao.UserDao;
import beautiful06.entity.User;

import com.ozacc.mail.Mail;
import com.ozacc.mail.SendMail;

public class SendMailServiceImpl implements SendMailService {

	private static final Log LOG = LogFactory.getLog(SendMailServiceImpl.class);
	
	private UserDao userDao;
	public void setUserDao(UserDao userDao) {
		this.userDao = userDao;
	}
	
	private SendMail sendMail;
	public void setSendMail(SendMail sendMail) {
		this.sendMail = sendMail;
	}

	private void send(User user, String from, String subject, String body) {
		try {
			Mail mail = new Mail();
			mail.addTo(user.getMailAddress());
			mail.setFrom(from);
			mail.setSubject(subject);
			mail.setText(body);
			if (LOG.isDebugEnabled()) {
				LOG.debug("メールを送信します。 : mail=" + mail);
			}
			sendMail.send(mail);
			if (LOG.isDebugEnabled()) {
				LOG.debug("メールを送信しました。 : mail=" + mail);
			}
		} catch (Exception ex) {
			LOG.error(ex.getMessage(), ex);
		}
	}

	public void sendMail() {
		List<User> users = getUserList();
		for (User user : users) {
			send(user, "hoge@nulab.co.jp", "お知らせ", "テストです。");
		}
	}

	private List<User> getUserList() {
		return userDao.findSubscribeUserList();
	}
}
