package beautiful06.step4;

import javax.servlet.http.HttpServletRequest;

import org.seasar.cubby.action.Action;
import org.seasar.cubby.action.ActionResult;
import org.seasar.cubby.action.Forward;
import org.seasar.cubby.action.Redirect;
import org.seasar.cubby.action.Url;

@Url("step4")
public class SendMailAction extends Action {
	
	private SendMailService sendMailService;
	public void setSendMailer(SendMailService sendMailService) {
		this.sendMailService = sendMailService;
	}
	
	private HttpServletRequest request;
	public void setRequest(HttpServletRequest request) {
		this.request = request;
	}
	
	public ActionResult show() {
		return new Forward("step4.jsp");
	}

	public ActionResult send() {
		final SessionSendMailListener sendMailListener = new SessionSendMailListener();
		Thread thread = new Thread(new Runnable() {
			public void run() {
				// 通知用のオブジェクトを引数として渡す 
				sendMailService.sendMail(sendMailListener);
			}
		});
		thread.start();
		// 通知用のオブジェクトをセッションに格納 
		request.getSession().setAttribute("sendMailListener", sendMailListener);
		flash.put("notice", "送信しました。");
		return new Redirect("result.jsp");
	}

	public static class SessionSendMailListener implements SendMailListener {
		private SendMailEvent event;
		public synchronized void mailSended(SendMailEvent event) {
			this.event = event;
		}
		public SendMailEvent getCurrentSendMailEvent() {
			return this.event;
		}
	}
}
