package beautiful06.step5;

import javax.servlet.http.HttpServletRequest;

import org.seasar.cubby.action.Action;
import org.seasar.cubby.action.ActionResult;
import org.seasar.cubby.action.Forward;
import org.seasar.cubby.action.Redirect;
import org.seasar.cubby.action.Url;

@Url("step5")
public class SendMailAction extends Action {
	
	private SendMailService sendMailService;
	public void setSendMailer(SendMailService sendMailService) {
		this.sendMailService = sendMailService;
	}
	
	private HttpServletRequest request;
	public void setRequest(HttpServletRequest request) {
		this.request = request;
	}
	
	public ActionResult show() {
		return new Forward("step5.jsp");
	}

	public ActionResult send() {
		final SessionSendMailListener sendMailListener = new SessionSendMailListener();
		Thread thread = new Thread(new Runnable() {
			public void run() {
				sendMailService.sendMail(sendMailListener);
			}
		});
		thread.start();
		request.getSession().setAttribute("sendMailListener", sendMailListener);
		return new Redirect("result.jsp");
	}

	public ActionResult cancel() {
		SessionSendMailListener listener = (SessionSendMailListener) request.getSession().getAttribute("sendMailListener");
		if (listener != null) {
			// セッション上のオブジェクトにキャンセルを通知
			listener.setCanceled(true);
			flash.put("notice", "キャンセルしました。");
		} else {
			flash.put("notice", "キャンセル対象はありません。");
		}
		return new Redirect("result.jsp");
	}

	public static class SessionSendMailListener implements SendMailListener {
		private SendMailEvent event;
		private boolean canceled;
		public synchronized void mailSended(SendMailEvent event) {
			this.event = event;
		}
		public SendMailEvent getCurrentSendMailEvent() {
			return this.event;
		}
		public void setCanceled(boolean canceled) {
			this.canceled = canceled;
		}
		public boolean isCanceled() {
			return this.canceled;
		}
	}
}
